From 7aa5106e2bd22ce1ccdecd2d442c2a78bd8470d4 Mon Sep 17 00:00:00 2001
From: Chizi123 <build@jsrv.com>
Date: Tue, 20 Oct 2020 05:47:21 +0000
Subject: [PATCH] added function to check for packages in aur and in repos, also only print errors on add or build

---
 main.sh |   84 +++++++++++++++++++++++++++++++----------
 1 files changed, 63 insertions(+), 21 deletions(-)

diff --git a/main.sh b/main.sh
index 1317507..6a590f4 100755
--- a/main.sh
+++ b/main.sh
@@ -43,7 +43,7 @@
 # Usage: build_pkg [package name] [-f force]
 function build_pkg {
 	#check if PKGBUILD has updated, don't rebuild if hasn't changed
-	if [[ ! -z $(git pull | grep "Already up to date.") && -z $(echo $1 | grep git) && -z $2 ]]; then
+	if [[ ! -z $(git pull | grep "Already up to date.") && -z $(grep 'pkgver() {' PKGBUILD) && -z $2 ]]; then
 		return 2
 	fi
 
@@ -66,29 +66,43 @@
 		return 1
 	fi
 
-	#Get build artifact names
+	#Get build artifact names from PKGBUILD and build artifacts
+	#Remove duplicates from the list
 	source PKGBUILD
 	pkgs=()
+	ipkgs=()
 	for i in ${pkgname[@]}; do
 		#pkgs+=("$i-$pkgver-$pkgrel")
-		pkgs+=("$(find . -mindepth 1 -maxdepth 1 -type f -name "$1*.tar.*" -not -name "*.sig" | sed 's/^\.\///')")
+		ipkgs+=($(find . -mindepth 1 -maxdepth 1 -type f \( -name "$i*.pkg.tar.*" -o -name "$i*.src.tar.*" \) -not -name "*.sig" | sed 's/^\.\///'))
 	done
+	while read -r -d '' x; do pkgs+=("$x"); done < <(printf "%s\0" "${ipkgs[@]}" | sort -uz)
 
 	#Move package to repodir and add to repo db
 	#Dont change the database if rebuilt the same package at same release and version
+	flag=0
 	for i in ${pkgs[@]}; do
-		if [[ -f $REPODIR/$i ]]; then
-			pkgs=${pkgs[@]/$i}
-		else
-			rm -f $REPODIR/*$1*.tar.*
-			cp $i $REPODIR/
-			[[ "$SIGN" == "Y" ]] && cp $i.sig $REPODIR/
+		if [[ ! -f $REPODIR/$i ]]; then
+			flag=1
 		fi
 	done
+	if [[ $flag == 1 ]]; then
+		rm -f $REPODIR/*$1*.tar.*
+		for i in ${pkgs[@]}; do
+			cp $i $REPODIR/
+			[[ "$SIGN" == "Y" ]] && cp $i.sig $REPODIR/
+		done
+	else 
+		return;
+	fi
 
 	# Weird exceptions
 	if [[ "$1" == "zoom" ]]; then
 		rm zoom*_orig*.pkg.tar.xz
+		for i in ${pkgs[@]}; do
+			if [ -z "${i##*orig*}" ]; then
+				pkgs=${pkgs[@]/$i}
+			fi
+		done
 	fi
 
 	# Add package to waiting list to be added to repo db
@@ -105,9 +119,9 @@
 	while true; do
 		# Wait until package is at the top of the queue and add to db
 		if [[ "$(head -n1 $REPODIR/.waitlist)" == "$1" ]]; then
-			for i in ${pkgs[@]}; do
-				repo-add $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) $REPODIR/$i
-			done
+		#	for i in ${pkgs[@]}; do
+				repo-add $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) ${pkgs[@]}
+		#	done
 			while true; do
 				if [[ $(cat $REPODIR/.waitlist.lck) == 1 ]]; then
 					sleep 1
@@ -227,6 +241,30 @@
 	fi
 }
 
+#Check for packages moved to official repos or removed from the AUR
+function check {
+	rmlist=""
+	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq core | sort) | tr '\n' ' ')"
+	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq extra | sort) | tr '\n' ' ')"
+	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq community | sort) | tr '\n' ' ')"
+	removed=()
+	TMPFILE=$(mktemp)
+	for i in $(find $BUILDDIR -mindepth 1 -maxdepth 1 -type d); do
+		check_pkg $TMPFILE "$(echo $i | rev | cut -d'/' -f1 | rev)" &
+	done
+	wait
+	echo "Merged into official repos: $rmlist"
+	echo "Not in AUR: $(cat $TMPFILE | tr '\n' ' ')"
+	rm -f $TMPFILE
+}
+
+function check_pkg {
+	if [[ -z "$(curl -sI "https://aur.archlinux.org/packages/$2" | head -n1 | grep 200)" ]]; then
+		echo "$2" >> $1
+	fi
+}
+
+
 #Check config and create build folders
 #Set variables before usage
 # Usage: init
@@ -293,18 +331,22 @@
 		build_all $([[ "$2" == "-f" ]] && echo "-f");;
 	"remove")
 		remove ${@:2};;
+	"check")
+		check;;
 	*)
-		printf "Invalid usage\nUsage: $0 init|add|build-all\n";;
+		printf "Invalid usage\nUsage: $0 init|add|build-all|check\n";;
 esac
 
 # Error reporting, send email only for build-all as assuming an batch job for that
-if [[ -f $REPODIR/.errors ]]; then
-	ERRORS=$(cat $REPODIR/.errors | tr '\n' ' ')
-	rm $REPODIR/.errors
-	echo "Errors in packages: $ERRORS"
-	if [[ "$EMAIL" != "" && "$1" == "build-all" ]]; then
-		send_email $ERRORS
+if [[ $1 == "build-all" || $1 == "add" ]]; then
+	if [[ -f $REPODIR/.errors ]]; then
+		ERRORS=$(cat $REPODIR/.errors | tr '\n' ' ')
+		rm $REPODIR/.errors
+		echo "Errors in packages: $ERRORS"
+		if [[ "$EMAIL" != "" && "$1" == "build-all" ]]; then
+			send_email $ERRORS
+		fi
+	else
+		echo "All packages built successfully"
 	fi
-else
-	echo "All packages built successfully"
 fi

--
Gitblit v1.9.3